#include "hex.h"


// 16ַתΪֽ
unsigned char hexCharToByte(char hex) {
    if (hex >= '0' && hex <= '9') {
        return hex - '0';
    } else if (hex >= 'A' && hex <= 'F') {
        return hex - 'A' + 10;
    } else if (hex >= 'a' && hex <= 'f') {
        return hex - 'a' + 10;
    } else {
        return 0;
    }
}

// 16ַתΪֽ
unsigned char* hexStringToBytes(const char* hexString, size_t* byteArrayLength) {
    size_t length = strlen(hexString);
    if (length % 2 != 0) {
        fprintf(stderr, "Invalid hex string length.\n");
        return NULL;
    }

    *byteArrayLength = length / 2;
    unsigned char* byteArray = (unsigned char*)malloc(*byteArrayLength);
    if (byteArray == NULL) {
        perror("Error allocating memory");
        return NULL;
    }

    for (size_t i = 0; i < *byteArrayLength; i++) {
        byteArray[i] = (hexCharToByte(hexString[2 * i]) << 4) | hexCharToByte(hexString[2 * i + 1]);
    }

    return byteArray;
}

// ֽдļ
int writeBytesToFile(const char* filename, const unsigned char* byteArray, size_t byteArrayLength) {
    FILE* file = NULL;
    fopen_s(&file, filename, "wb");
    if (file == NULL) {
        perror("Error opening file");
        return 1;
    }

    size_t written = fwrite(byteArray, 1, byteArrayLength, file);
    if (written != byteArrayLength) {
        perror("Error writing to file");
        fclose(file);
        return 1;
    }

    fclose(file);
    return 0;
}
